var canvas;
var cntx;

function init(){
	canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
	$("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });

    window.addEventListener("beforeunload",function(e){
        clearInterval(timerLoop);
    });
}

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    $("#ColorSchemes").val("palette");
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Εικόνες
    drawIntroImage();
    drawLogoImage();
    //Κουμπιά

    if(introStep>=introNoTemp && introStep<=introOtherTemp || introStep==introNoTempCorrect){
        $("#editTools").show();
        if($("#chkManualControl").prop("checked")){
            $("#simulateAuto").hide();
            $("#simulateManual").show();
        }
        else{
            $("#simulateManual").hide();
            $("#simulateAuto").show();
        }
        showUserPrompts();
    }
    else{
        $("#editTools").hide();
        Drawing=false;
    }

    if(ShowNextStepButton()){
        drawButtonNext();
    }
    if(introStep>1){
    	drawButtonBack();
    }
    DrawSimulations();
}

function ShowNextStepButton(){
    return (introStep<introNoTempCorrect && introStep!=introTwoTemp) || (introStep==introTwoTemp && LoopCounter==MaxLoopCounter);      
}

function showUserPrompts(){
    var vTxtOffset=25;
    var promptYCoord;
    promptYCoord=BottomPanelTop+20;
    if($("#chkManualControl").prop("checked")){
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Κάνε κλικ στο κουμπί [Προηγούμενο Βήμα] για να οπισθοχωρήσεις την εκτέλεση του αλγόριθμου.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Κάνε κλικ στο κουμπί [Επόμενο Βήμα] για να προχωρήσεις την εκτέλεση του αλγόριθμου.");
        promptYCoord=promptYCoord+vTxtOffset;
    }
    else{
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Κάνε κλικ στο check box για να περάσεις σε χειροκίνητη εκτέλεση του αλγόριθμου.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Χρησιμοποίησε τη μπάρα κύλησης για να αυξομειώσεις την ταχύτητα εκτέλεσης του αλγόριθμου.");
        promptYCoord=promptYCoord+vTxtOffset;
    }
    if(introStep==introTwoTemp && LoopCounter==MaxLoopCounter){
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Προσπάθησε να παρατηρήσεις πότε χάνει την αρχική τιμή της η μεταβλητή b.");
    }
}

function drawIntroImage(){
	Intro=document.getElementById("img"+introStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    if(fontName!=""){
    	cntx.font=fontSize+"px "+fontName;
    }
    if(clr!=""){
    	cntx.fillStyle=clr;
    }
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){

}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    
    if(!Drawing)drawBasicScreen();
    if(debug)console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introLastStep && ShowNextStepButton()){
        introStep++;
        LoadCommands();
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1){
        introStep--;
        LoadCommands();
    }
    drawBasicScreen();
}

function drawPattern(){
    if(Drawing){
        if(!$("#chkManualControl").prop("checked")){
            if (introStep>=introNoTemp && introStep<=introOtherTemp || introStep==introNoTempCorrect){
                AdvanceRedColorStep();
            }
        }
    }
}

function resetDrawingLoop(){
    LoopCounter=0;
    clearInterval(timerLoop);
    Drawing=true;
    if(introStep>=introNoTemp && introStep<=introOtherTemp || introStep==introNoTempCorrect){
        var newSpeed=parseInt($("#HScrDrawSpeed").attr("max"))-parseInt($("#HScrDrawSpeed").val());
        timerLoop=setInterval(function(){drawPattern();},newSpeed);
    }
}

function AdvanceRedColorStep(){
    RedColorStep++;
    if(RedColorStep==MaxNoOfSteps){
        RedColorStep=-1;
        if(introStep==introTwoTemp && LoopCounter<MaxLoopCounter) LoopCounter++;
    }
    drawBasicScreen();
}

function BacktrackRedColorStep(){
    RedColorStep--;
    if(RedColorStep==-2) RedColorStep=MaxNoOfSteps-1;
    drawBasicScreen();
}

function LoadCommands(){
    if(introStep==introNoTemp){
        Command[0][0]="a <-- 10";
        a[0][0]="10";
        b[0][0]="";
        Command[1][0]="b <-- 20";
        a[1][0]="10";
        b[1][0]="20";
        Command[2][0]="a <-- b";
        a[2][0]="20";
        b[2][0]="20";
        Command[3][0]="b <-- a";
        a[3][0]="20";
        b[3][0]="20";
        MaxNoOfSteps=4;
        RedColorStep=-1;
        VarXCoord=475;
        CommandXCoord=180;
        CommandYCoord=265;
    }
    else if(introStep==introTwoTemp){
        Command[0][0]="a <-- 10";
        a[0][0]="10";
        b[0][0]="";
        x[0][0]="";
        y[0][0]="";
        Command[1][0]="b <-- 20";
        a[1][0]="10";
        b[1][0]="20";
        x[1][0]="";
        y[1][0]="";
        Command[2][0]="x <-- a";
        a[2][0]="10";
        b[2][0]="20";
        x[2][0]="10";
        y[2][0]="";
        Command[3][0]="y <-- b";
        a[3][0]="10";
        b[3][0]="20";
        x[3][0]="10";
        y[3][0]="20";
        Command[4][0]="a <-- y";
        a[4][0]="20";
        b[4][0]="20";
        x[4][0]="10";
        y[4][0]="20";
        Command[5][0]="b <-- x";
        a[5][0]="20";
        b[5][0]="10";
        x[5][0]="10";
        y[5][0]="20";
        MaxNoOfSteps=6;
        RedColorStep=-1;
        VarXCoord=500;
        CommandXCoord=180;
        CommandYCoord=265;
    }
    else if(introStep==introOneTemp){
        Command[0][0]="a <-- 10";
        a[0][0]="10";
        b[0][0]="";
        x[0][0]="";
        y[0][0]="";
        Command[1][0]="b <-- 20";
        a[1][0]="10";
        b[1][0]="20";
        x[1][0]="";
        y[1][0]="";
        Command[2][0]="x <-- a";
        a[2][0]="10";
        b[2][0]="20";
        x[2][0]="10";
        y[2][0]="";
        Command[3][0]="a <-- b";
        a[3][0]="20";
        b[3][0]="20";
        x[3][0]="10";
        y[3][0]="";
        Command[4][0]="b <-- x";
        a[4][0]="20";
        b[4][0]="10";
        x[4][0]="10";
        y[4][0]="";
        MaxNoOfSteps=5;
        RedColorStep=-1;
        VarXCoord=500;
        CommandXCoord=180;
        CommandYCoord=265;
    }
    else if(introStep==introOtherTemp){
        Command[0][0]="a <-- 10";
        a[0][0]="10";
        b[0][0]="";
        x[0][0]="";
        y[0][0]="";
        Command[1][0]="b <-- 20";
        a[1][0]="10";
        b[1][0]="20";
        x[1][0]="";
        y[1][0]="";
        Command[2][0]="x <-- b";
        a[2][0]="10";
        b[2][0]="20";
        x[2][0]="20";
        y[2][0]="";
        Command[3][0]="b <-- a";
        a[3][0]="10";
        b[3][0]="10";
        x[3][0]="20";
        y[3][0]="";
        Command[4][0]="a <-- x";
        a[4][0]="20";
        b[4][0]="10";
        x[4][0]="20";
        y[4][0]="";
        MaxNoOfSteps=5;
        RedColorStep=-1;
        VarXCoord=500;
        CommandXCoord=180;
        CommandYCoord=265;
    }
    else if(introStep==introNoTempCorrect){
        Command[0][0]="a <-- 10";
        a[0][0]="10";
        b[0][0]="";
        x[0][0]="";
        y[0][0]="";
        Command[1][0]="b <-- 20";
        a[1][0]="10";
        b[1][0]="20";
        x[1][0]="";
        y[1][0]="";
        Command[2][0]="a <-- a + b";
        a[2][0]="30";
        b[2][0]="20";
        x[2][0]="";
        y[2][0]="";
        Command[3][0]="b <-- a - b";
        a[3][0]="30";
        b[3][0]="10";
        x[3][0]="";
        y[3][0]="";
        Command[4][0]="a <-- a - b";
        a[4][0]="20";
        b[4][0]="10";
        x[4][0]="";
        y[4][0]="";
        
        Command[0][1]="a <-- 10";
        a[0][1]="10";
        b[0][1]="";
        x[0][1]="";
        y[0][1]="";
        Command[1][1]="b <-- 20";
        a[1][1]="10";
        b[1][1]="20";
        x[1][1]="";
        y[1][1]="";
        Command[2][1]="a <-- a * b";
        a[2][1]="200";
        b[2][1]="20";
        x[2][1]="";
        y[2][1]="";
        Command[3][1]="b <-- a / b";
        a[3][1]="200";
        b[3][1]="10";
        x[3][1]="";
        y[3][1]="";
        Command[4][1]="a <-- a / b";
        a[4][1]="20";
        b[4][1]="10";
        x[4][1]="";
        y[4][1]="";
        
        MaxNoOfSteps=5;
        RedColorStep=-1;
        VarXCoord=270;
        CommandXCoord=65;
        CommandYCoord=280;
    }
    resetDrawingLoop();
}

function handleManualSwitch(){
    Drawing=!$("#chkManualControl").prop("checked");
    drawBasicScreen();
}

function DrawSimulations(){
    var colorToUse="rgb(0,0,0)";
    var fontSizeToUse=algorithmFontSize;
    var SecondAlgorithmOffset=320;
    var dYCoord=23,LastAlgorithm,j;
    if(introStep>=introNoTemp && introStep<=introOtherTemp || introStep==introNoTempCorrect){
        if(introStep==introNoTempCorrect){
            VarYCoord=331;
            LastAlgorithm=2;
        }
        else{
            VarYCoord=285;
            LastAlgorithm=1;
        }
        for(var CurrentStep=0;CurrentStep<MaxNoOfSteps;CurrentStep++){
            if(CurrentStep==RedColorStep){
                colorToUse="rgb(255,0,0)";
            }
            else{
                colorToUse="rgb(0,0,255)";
            }
            for(j=0;j<LastAlgorithm;j++){
                cnvsWrite(colorToUse,fontSizeToUse,"Arial",CommandXCoord+j*SecondAlgorithmOffset,CommandYCoord+CurrentStep*25,Command[CurrentStep][j]);
            }
        }
        if(RedColorStep>-1){
            for(j=0;j<LastAlgorithm;j++){
                if(RedColorStep==0){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else if(a[RedColorStep][j]!=a[RedColorStep-1][j]){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else{
                    fontSizeToUse=algorithmFontSize-6;
                    colorToUse="rgb(0,0,0)";
                }
                cnvsWrite(colorToUse,fontSizeToUse,"Arial",VarXCoord+j*SecondAlgorithmOffset,VarYCoord,a[RedColorStep][j]);
            }
            VarYCoord=VarYCoord+dYCoord;
            for(j=0;j<LastAlgorithm;j++){
                if(RedColorStep==0){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else if(b[RedColorStep][j]!=b[RedColorStep-1][j]){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else{
                    fontSizeToUse=algorithmFontSize-6;
                    colorToUse="rgb(0,0,0)";
                }
                cnvsWrite(colorToUse,fontSizeToUse,"Arial",VarXCoord+j*SecondAlgorithmOffset,VarYCoord,b[RedColorStep][j]);
            }
            if(introStep>=introTwoTemp && introStep<=introOtherTemp){
                VarYCoord=VarYCoord+dYCoord;
                if(RedColorStep==0){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else if(x[RedColorStep][0]!=x[RedColorStep-1][0]){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else{
                    fontSizeToUse=algorithmFontSize-6;
                    colorToUse="rgb(0,0,0)";
                }
                cnvsWrite(colorToUse,fontSizeToUse,"Arial",VarXCoord,VarYCoord,x[RedColorStep][0]);
                VarYCoord=VarYCoord+dYCoord;
                if(RedColorStep==0){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else if(y[RedColorStep][0]!=y[RedColorStep-1][0]){
                    fontSizeToUse=algorithmFontSize-4;
                    colorToUse="rgb(255,0,0)";
                }
                else{
                    fontSizeToUse=algorithmFontSize-6;
                    colorToUse="rgb(0,0,0)";
                }
                cnvsWrite(colorToUse,fontSizeToUse,"Arial",VarXCoord,VarYCoord,y[RedColorStep][0]);
            }
        }
    }
}